import os
import json
import base64
import win32crypt
import shutil
import sqlite3
from Cryptodome.Cipher import AES


def decrypt_password(enc_pswd, m_key):
    try:
        # ciphertext = 3B prefix + 12B nonce + payload (niektore verzie Chrome nemaju 3B prefix)
        nonce = enc_pswd[3:15]  # nonce
        print('nonce = ' + ' '.join(format(nonce[i], '02x') for i in range(0, len(nonce))))
        payload = enc_pswd[15:]  # payload
        print('payload = ' + ' '.join(format(payload[i], '02x') for i in range(0, len(payload))))
        # AES sifra, key = master_key, mode = AES-256-GCM (Galois Counter Mode), nonce = nonce
        cipher = AES.new(m_key, AES.MODE_GCM, nonce)
        # desifrovanie hesla
        decrypted_pass = cipher.decrypt(payload)
        # odstranenie poslednych 16B (authentication tag) a nasledne prevod bytes na string
        decrypted_pass = decrypted_pass[:-16].decode()
        return decrypted_pass
    except (ValueError, KeyError):
        return 'Na dešifrovanie hesla je nutné použiť iný algoritmus'


print('--------------------------------------------------------------------------------------------------')
enc_master_key_file = os.environ['USERPROFILE'] + os.sep + r'AppData\Local\Google\Chrome\User Data\Local State'
print('MasterKey súbor: ' + enc_master_key_file)
print('--------------------------------------------------------------------------------------------------')
with open(enc_master_key_file, 'r') as f:
    local_state = f.read()  # nacitanie obsahu suboru = bytes
    local_state = json.loads(local_state)  # rozdelenie bytes v JSON formate na Dictionary
# dekodovanie enc_master_key, ktory bol ulozeny v Base64 formate, na bytes
enc_master_key = base64.b64decode(local_state['os_crypt']['encrypted_key'])
# ostranenie textu 'DPAPI' z enc_master_key (Data Protection Application Programming Interface)
enc_master_key = enc_master_key[5:]
print('Zašifrovaný master_key: ', enc_master_key)
print('--------------------------------------------------------------------------------------------------')
# desifrovanie master_key, ktory bol zasifrovany pomocou win32crypt.CryptProtectData
# vysledok je Tuple (description, data) kde data = desifrovany master_key
master_key = win32crypt.CryptUnprotectData(enc_master_key, None, None, None, 0)[1]
print('Dĺžka master_key = ' + str(len(master_key)))
print('Dešifrovaný master_key: ' + ' '.join(format(master_key[i], '02x') for i in range(0, len(master_key))))
print('--------------------------------------------------------------------------------------------------')

login_db = os.environ['USERPROFILE'] + os.sep + r'AppData\Local\Google\Chrome\User Data\default\Login Data'
print('Login databáza: ' + login_db)
print('--------------------------------------------------------------------------------------------------')
shutil.copy2(login_db, "temp.db")  # vytvorenie temp.db (Login Data dB je zamknuta ak je Chrome spusteny)
con = sqlite3.connect("temp.db")
cursor = con.cursor()
try:
    # vykonanie dB prikazu - vyber poloziek action_url, username_value a password_value z tabulky logins
    cursor.execute("SELECT action_url, username_value, password_value FROM logins")
    # pre vsetky riadky tabulky
    for r in cursor.fetchall():
        url = r[0]
        username = r[1]
        encrypted_password = r[2]
        if len(username) > 0:
            print('Zašifrované heslo: ', encrypted_password)
            print('URL: ' + url)
            print('Používateľské meno: ' + username)
            # desifrovanie hesla pomocou master_key
            print ('Dešifrované heslo: ' + decrypt_password(encrypted_password, master_key))
            print('--------------------------------------------------------------------------------------------------')
except Exception as e:
    pass
cursor.close()
con.close()

try:
    os.remove("temp.db")  # odstranenie temp.db
except Exception as e:
    pass
